#!/bin/sh
#
# L2TPns apply script
# Applies the uci configuration to l2tpns' configuration file /etc/l2tpns/startup-config
#
# Author: Liran Tal <liran@enginx.com>
#                   <liran.tal@gmail.com>
#
# Last edited: 27 Nov 2007 - added support for proper restart of l2tpns service
#

#==============================================================================
# Exporting the uci configuration settings to the startup-config file
#==============================================================================

. /etc/functions.sh

config_cb() {
	local cfgtype="$1"
	local name="$2"
	[ "$cfgtype" = "server" ] && server_cfg="$name" || unset server_cfg
}

option_cb() {
	local varname="$1"; shift
	local value="$*"
	local tvalue
	[ -n "$server_cfg" ] && [ -n "$value" ] && {
		case "$varname" in
			mode) ;;
			debug)
				let tvalue=value+1
				[ "$tvalue" -gt 1 ] && l2tpns_options="${l2tpns_options}set ${varname} ${value}${_lf}"
			;;
			*) [ -n "$value" ] && l2tpns_options="${l2tpns_options}set ${varname} ${value}${_lf}" ;;
		esac
	}
}

_lf="
"
l2tpns_config_dir="/etc/l2tpns"
l2tpns_config="$l2tpns_config_dir/startup-config"
l2tpns_options="# The L2TPns config file${_lf}# this file is automatically generated by webif^2${_lf}"
[ -d "$l2tpns_config_dir" ] && {
	config_load l2tpns
	echo "$l2tpns_options" > "$l2tpns_config"
}
